<!--官方召回 created By 1173944134@qq.com-->
<template>
    <!--课堂icon-->
    <div class="official-icon" id="OfficialListIcon">
        <img src="" class="icon icon_1"/>
        <img src="" class="icon icon_2"/>
    </div>
    <!--试看课程目录-->
    <div class="flex-row official-free-cslist" id="OfficialFreeCSList">
        <div class="flex-row time-con">距特惠结束</div>
        <div class="flex-row btn-con">
            <div class="flex-row dang">
                <div class="price"></div>
                <div class="desc">单独全价购</div>
            </div>
            <div class="flex-row tuang">
                <div class="flex-row price">
                    <div class="mark">(已减3元)</div>
                </div>
                <div class="desc">发起3人团</div>
            </div>
            <div class="flex-row badge">
                <div class="t">8折</div>
            </div>
        </div>
    </div>
    <!--toast-->
    <div class="yidialog-con yid-toast-con" id="toastCon">
        <div class="yid-back"></div>
        <div class="yid-con flex-row">
            <div class="yid-con-body flex-row">
                <!--消息-->
                <div class="msg"></div>
            </div>
        </div>
    </div>
    <!--优惠券弹窗-->
    <div class="yidialog-con official-cslist-cpdia" id="OffiCsCpDia">
        <div class="yid-back"></div>
        <div class="yid-con flex-row yid-con-col">
            <div class="yid-con-body flex-row">
                <div class="kj-djs"></div>
                <img src="" class="coupon-img"/>
                <div class="go-btn"></div>
                <div class="btn-baom-con"></div>
            </div>
        </div>
    </div>
    <!--选课-->
    <div class="yidialog-con official-cslist-csdia" id="OffiCsCsDia">
        <div class="yid-back"></div>
        <div class="yid-con flex-row yid-con-col">
            <div class="yid-con-body flex-row">
                <div class="kj-djs">任选一门课7天免费看</div>
                <div class="flex-row cs-con">
                    <div class="cs-one">
                        <img src="" class="img"/>
                    </div>
                </div>
                <img src="" class="cs-img" style="display: none;"/>
                <div class="flex-row go-btn">确认</div>
                <div class="btn-baom-con"></div>
            </div>
        </div>
    </div>
    <!--弹窗-->
    <div class="yidialog-con" id="Dia">
        <div class="yid-back"></div>
        <div class="yid-con flex-row yid-con-col">
            <div class="yid-con-body flex-row">
                <div class="kj-djs"></div>
                <img src="" style="display: none;" class="coupon-img"/>
                <div class="btn-baom-con">
                    <img src="" class="btn-baom heart-beat"/>
                </div>
            </div>
            <div class="yid-cls-con">
                <img src="" class="yid-cls"/>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        name: 'official_recall',
        data: {
            couponConfigId: 1169,
            ver: window.jspVersionMoreChange,
            userType: ApiHelper.SERVER + '/dengta/common/act/10050/userType.json', // 用户类型
            visitRecord: ApiHelper.SERVER + '/dengta/common/act/10050/visitRecord.json', // 用户访问记录
            showEntry: ApiHelper.SERVER + '/dengta/common/act/10047/showEntry.json',
            sendCoupon: ApiHelper.SERVER + '/dengta/coupon/distribute.json',
            freeCourseListUrl: ApiHelper.SERVER + '/dengta/coupon/give/details.json',
            exchangeCourseUrl: ApiHelper.SERVER + '/dengta/coupon/freeCourse/exchangeCourses.json',
            courseImg: resourcePath + '/imgs/groupPurchase/newCourseImg/',
            imgPath: resourcePath + '/imgs/groupPurchase/act/callsilent/',
            pvuv: ApiHelper.SERVER + '/dengta/common/act/10029/addPvuv.json' // pvuv微信通用接口
        },
        // pvuvkey
        pvuvKey: {},
        // 接口数据
        actData: {
            giveCourses: [],
            countDownTime: 0,
            userCouponConfigId: 0,
            actId: 10047,
            status: 0 // 0-不能参加，1-可以参加，2-已购买
        },
        exposeMap: {},
        // 曝光统计
        sendExposePvuv: function (data, callback) {
            data = data || {}
            !data.pvuvKeyId && (data.pvuvKeyId = 947)
            data.actChannels = data.channel
            var url = this.data.pvuv
            if (data.actId) {
                url = url.replace('10029', data.actId)
            } else {
                url = url.replace('10029', 10038)
            }
            delete data.channel
            if (!data.expParam) {
                data.expParam = {
                    module: '',
                    tag: '',
                    relateId: data.relateId,
                    channel: data.actChannels
                }
            }
            $.get(url, data)
            callback && setTimeout(callback, 300)
        },
        addPvuv: function (data, callback) {
            ApiHelper.myLog('pvuv>>>>', data)
            $.get(data.url || this.data.pvuv, data)
            callback && setTimeout(callback, 300)
        },
        // 初始化
        init: function () {
            ApiHelper.moreCourse && this.initMoreCourse()
            ApiHelper.courseList && this.initCourseList()
            ApiHelper.sectionList && this.initSectionList()
            ApiHelper.userProfile && this.initUserProfile()
            ApiHelper.freeCourseList && this.initFreeCourseList()
            ApiHelper.sectionContent && this.initSectionContent()
            ApiHelper.scoreIndex && this.initScoreIndex()
            ApiHelper.courseDetails && this.officialStat()
            ApiHelper.collageDetail && this.officialStat()
        },
        getUserStatus: function (options) {
            var callback = function () {
            }
            if (typeof options === 'function') {
                callback = options
            }
            $.post(this.data.showEntry, function (res) {
                var resData = res.value
                if (!resData) {
                    return
                }
                callback && callback()
            })
        },
        // 商城首页
        initMoreCourse: function () {
            var that = this
            ApiHelper.$on('notificationPvuc', function (e, data) {
                if (!data || !data.item) {
                    return
                }
                var type = data.type // "expose" click
                var item = data.item
                if (type === 'expose' && item.cacheKey === 'silent_course_dialog_v2') {
                    var redirectUrl = item.redirectUrl || ''
                    that.sendExposePvuv({
                        pvuvKeyId: 1377,
                        actId: 1,
                        channel: that.getQueryVal('channel', redirectUrl)
                    })
                }
            })
            ApiHelper.$on('homeBannerPvuv', function (e, data) {
                if (!data) {
                    return
                }
                var type = data.type // "expose" click
                var link = data.link || ''
                var id = data.id
            })
            that.officialStat()
        },
        // 官方召回统计
        officialStat: function () {
            var that = this
            var officialKey = 'official_data'
            var officiaData = this.getStorageSync(officialKey) || {}
            var data = officiaData.data || {}
            var userType = data.userType
            var code = 0

            if (ApiHelper.courseList) {
                code = 3
                checkUserType()
            }
            ApiHelper.$on('indexModuleChange', function (e, data) {
                var tabcategorieid = '' + (data && data.tabcategorieid || '')
                code = tabcategorieid === '1' ? 1 : 4
                checkUserType()
            })

            if (ApiHelper.sectionContent) {
                code = ApiHelper.getQueryString('isDailyFree') === 'true' ? 12 : 11
                checkUserType()
            }
            var pageName = $('body').data('page-name') // collageDetails  courseDetails
            if (pageName === 'courseDetails') {
                code = 13
                checkUserType()
            } else if (pageName === 'collageDetails') {
                ApiHelper.$on('judgeOpenGroupUser', function (e, data) {
                    code = data.isGrouper ? 21 : 22
                    checkUserType()
                })
            }

            function checkUserType() {
                if (userType !== undefined) {
                    postPvuv()
                    return
                }
                $.post(that.data.userType, function (res) {
                    var resData = res.value
                    userType = resData
                    var time = new Date().getTime()
                    that.setStorageSync(officialKey, {
                        data: {
                            userType: userType
                        },
                        meta: {
                            start: time,
                            end: time + '-1',
                            life: '-1'
                        }
                    })
                    postPvuv()
                })
            }

            function postPvuv() {
                if (userType === undefined || userType <= 0) {
                    return
                }
                code && $.post(that.data.visitRecord, {
                    userType,
                    code
                })
            }
        },
        // 学分商城
        initScoreIndex: function () {
            var is = ApiHelper.getQueryString('pfrom') === 'call' || window.showGiveCouponEntry === 'false'
            if (!is) {
                return
            }
            var that = this
            $('.get105-score-flag-wrap').remove()
            var scrollExpose = ApiHelper.throttle(function () {
                $('.commodity').each(function (idx, one) {
                    var id = $(one).data('id')
                    var selector = '.commodity[data-id="' + id + '"]'
                    if (that.isHideView(selector)) {
                        that.exposeMap[id] = false
                    }
                    if (that.isInView({selector: selector}) && !that.exposeMap[id]) {
                        // 曝光
                        that.exposeMap[id] = true
                        that.sendExposePvuv({
                            pvuvKeyId: 1498,
                            actId: 10050,
                            relateId: id
                        })
                    }
                })
            }, 500)
            document.addEventListener('scroll', scrollExpose)
            ApiHelper.$on('giftLoad', function () {
                scrollExpose()
            })
            ApiHelper.$on('giftPvuv', function (e, data) {
                if (!data) {
                    return
                }
                var id = data.id
                that.sendExposePvuv({
                    pvuvKeyId: 1499,
                    actId: 10050,
                    relateId: id
                })
            })
        },
        // 课程播放
        initSectionContent: function () {
            this.officialStat()
        },
        // 获取url第一个参数
        getQueryVal: function (key, str) {
            var search = str.split('?') || []
            search = search[1] || ''
            search = search.split('&') || []
            var val = ''
            for (var i = 0; i < search.length; i++) {
                var arr = search[i].split('=')
                if (arr[0] === key) {
                    val = arr[1]
                    break
                }
            }
            return val
        },
        // 试看课列表
        initFreeCourseList: function () {
            var that = this
            if (ApiHelper.getQueryString('freeSource') !== '10') {
                return
            }
            $('.sectionListHtml').css({
                paddingBottom: '1.6rem'
            })
            window.channel = window.channel || '-1'
            window.newCourseId = window.newCourseId || ''
            window.orderSource = window.orderSource || ''
            window.courseId = ApiHelper.getQueryString('courseId')
            if (typeof posterOpenId === 'undefined') {
                window.posterOpenId = 'natureSubPoster'
            }
            ApiHelper.loadJS({
                path: resourcePath + '/plugin/better-scroll/bscroll.min.js?v=' + this.data.ver,
                callback: function () {
                    that._initFreeCourseList()
                }
            })
        },
        showCouponTimeDown: function () {
            var that = this
            if ($('#OfficialFreeCSList').length === 0 || that.countDownTime || !that.actData.countDownTime) {
                return
            }
            if (that.actData.countDownTime > 0) {
                that.countDownTime = true
                $('#OfficialFreeCSList .time-con').css('display', 'flex')
                $('#OfficialFreeCSList .badge').css('display', 'flex')
            }
            new NewTimer(that.actData.countDownTime, function (timeArr) {
                $('#OfficialFreeCSList .time-con').text('距特惠结束 ' + timeArr[1] + ' : ' + timeArr[2] + ' : ' + timeArr[3])
            }, function () {
                $('#OfficialFreeCSList .time-con').hide()
                $('#OfficialFreeCSList .badge').hide()
            }, 1000).startCountDown()
        },
        _initFreeCourseList: function () {
            var that = this
            window.titleId = ApiHelper.getQueryString('titleId') || ''
            window.rgn = ApiHelper.getQueryString('rgn')
            ApiHelper.loadJS({
                path: resourcePath + '/js/groupBuy/pay.js?v=' + this.data.ver,
                callback: function () {
                    triggerUpdata()
                }
            })

            function triggerUpdata() {
                $('body').trigger('upPayData', {
                    onlyCoupon: true,
                    isGroupBuy: true,
                    isGroupFullSign: true,
                    callback: function (data) {
                        if (!data) {
                            return
                        }
                        var priceMaxCoupon = data.priceMaxCoupon || {}
                        that.actData.countDownTime = parseInt(priceMaxCoupon.countDownTime) || 0
                        if (priceMaxCoupon.couponConfigId !== 733) {
                            that.actData.countDownTime = 0
                        }
                        that.showCouponTimeDown()
                        $('#OfficialFreeCSList .dang .price').text('￥' + data.baseSingleBuyPrice)
                        var mk = parseInt(data.benefitNumYuan) > 0 ? ('<div class="mark">(已减' + data.benefitNumYuan + '元)</div>') : ''
                        $('#OfficialFreeCSList .tuang .price').html('￥' + data.groupBuyPrice + mk)
                    }
                })
            }

            var isGroupBuy = false
            ApiHelper.$on('getCourseBasicInfo', function (e, data) {
                if (!data) {
                    return
                }
                var courseName = data.courseName
                if (courseName) {
                    document.title = courseName
                }
                var buyName = isGroupBuy ? (data.groupTopNumber + '人拼团购') : '单独全价购'
                $('.buyway_tab .name').text(buyName)
                $('#OfficialFreeCSList .tuang .desc').text('发起' + data.groupTopNumber + '人团')
            })
            $(OfficialFreeCSList).appendTo($('body'))
            that.sendExposePvuv({
                pvuvKeyId: 1422,
                actId: that.actData.actId
            })
            $('#OfficialFreeCSList .time-con').css({
                backgroundImage: 'url("' + that.data.imgPath + 'djs-back.png?v=' + window.jspVersionMoreChange + '")'
            })
            that.showCouponTimeDown()

            // 显示商品详情
            function showPayBox(flag) {
                $('body').trigger('upPayData', {
                    isGroupBuy: flag
                })
                isGroupBuy = flag
                $('.alert_bg').show().css({
                    zIndex: 89
                });
                $('.pay_box').addClass('open').removeClass('close');
                that.sendExposePvuv({
                    pvuvKeyId: 1421,
                    actId: that.actData.actId
                })
            }

            $('#OfficialFreeCSList .dang').click(function () {
                showPayBox(false)
            })
            $('#OfficialFreeCSList .tuang').click(function () {
                showPayBox(true)
            })
        },
        // 课程目录页
        initSectionList: function () {
            var channel = ApiHelper.getQueryString('channel')
            $.inArray(channel, ['230100001', '230100002']) !== -1 && this.sendExposePvuv({
                pvuvKeyId: 1353,
                actId: 1,
                channel: channel
            })
        },
        // 我的课
        initCourseList: function () {
            var that = this
            that.officialStat()
            that.getUserStatus(function () {
                that.sendExposePvuv({
                    pvuvKeyId: 1404,
                    actId: that.actData.actId
                })
                $(OfficialListIcon).appendTo($('body'))
                $('#OfficialListIcon .icon_1').attr('src', that.data.imgPath + 'cslist-icon1.png?v=' + that.data.ver)
                $('#OfficialListIcon .icon_2').attr('src', that.data.imgPath + 'cslist-icon2.png?v=' + that.data.ver)
                $('#OfficialListIcon').click(function () {
                    that.sendExposePvuv({
                        pvuvKeyId: 1403,
                        actId: that.actData.actId,
                        callback: function () {
                            location.href = ApiHelper.getActUrl() + '/official/friend'
                        }
                    })
                })
                var nowIdx = 0
                var delay = 100
                setInterval(function () {
                    nowIdx++
                    $('#OfficialListIcon .icon_2').animate({
                        height: '1.08rem'
                    }, delay)
                    $('#OfficialListIcon .icon_1').animate({
                        marginTop: '-1.08rem'
                    }, delay, function () {
                        $('#OfficialListIcon .icon').css({
                            marginTop: 0
                        })
                        $('#OfficialListIcon .icon_1').attr('src', that.data.imgPath + 'cslist-icon' + (nowIdx % 2 === 0 ? 1 : 2) + '.png?v=' + that.data.ver)
                        $('#OfficialListIcon .icon_2').attr('src', that.data.imgPath + 'cslist-icon' + (nowIdx % 2 === 0 ? 2 : 1) + '.png?v=' + that.data.ver)
                        $('#OfficialListIcon .icon_2').css({
                            height: 0
                        })
                    })
                }, 1700)
                if (ApiHelper.getQueryString('calldia') !== '1') {
                    return
                }
            })
            if (ApiHelper.getQueryString('calldia') !== '1') {
                return
            }
            that.showCouponDia()
        },
        // 显示优惠券弹窗
        showCouponDia: function () {
            var that = this
            $(OffiCsCpDia).appendTo($('body'))
            $('#OffiCsCpDia .yid-con-body').css({
                backgroundImage: 'url("' + that.data.imgPath + 'giftWrap.png?v=' + window.jspVersionMoreChange + '")'
            })
            $('#OffiCsCpDia .yid-cls').attr('src', that.data.imgPath + 'close-x.png?v=' + that.data.ver)
            $('#OffiCsCpDia .coupon-img').attr('src', that.data.imgPath + 'giftBox.png?v=' + that.data.ver)
            $.post(that.data.sendCoupon, {
                couponConfigId: that.data.couponConfigId,
                courseId: ApiHelper.getQueryString('courseId') || 61
            }, function (res) {
                var resData = res.value || {}
                if (!resData.id) {
                    alert('领取失败，请联系老师反馈哦~')
                    return
                }
                // 已领过
                if (resData.couponState === 2) {
                    $('#OffiCsCpDia').hide()
                    return
                }
                that.actData.userCouponConfigId = resData.id
                that.getCouponDetail()
                setTimeout(function () {
                    showCoupon()
                }, 1500)
            })
            var step = 0 // 进行哪一步
            function showCoupon() {
                step = 1
                $('#OffiCsCpDia .yid-con-body').css({
                    backgroundImage: 'url("' + that.data.imgPath + 'giftCoupon_course.png?v=' + window.jspVersionMoreChange + '")'
                })
                $('#OffiCsCpDia .coupon-img').hide()
            }

            $('#OffiCsCpDia .go-btn').click(function () {
                if (step === 0) {
                    showCoupon()
                }
                if (step === 1) {
                    that.showCourseDia()
                }
            })
            $('#OffiCsCpDia .btn-baom-con').click(function () {
                $('#OffiCsCpDia').hide()
            })
        },
        getCouponDetail: function () {
            var that = this
            $.post(that.data.freeCourseListUrl, {
                userCouponConfigId: that.actData.userCouponConfigId
            }, function (res) {
                var resData = res.value || {}
                var len = resData.giveCourses && resData.giveCourses.length
                if (len < 1) {
                    that.showToast(resData.desc || '暂无可适用的课程')
                    $('#OffiCsCpDia').hide()
                    return
                }
                that.actData.giveCourses = resData.giveCourses || []
                if ($('#OffiCsCsDia').length > 0) {
                    that.showCourseDia()
                }
            })
        },
        // 显示选课
        showCourseDia: function () {
            var that = this
            $('#OffiCsCpDia').hide()
            $(OffiCsCsDia).appendTo($('body'))
            $('#OffiCsCsDia .yid-con-body').css({
                backgroundImage: 'url("' + that.data.imgPath + 'getCourse_choose.png?v=' + window.jspVersionMoreChange + '")'
            })
            $('#OffiCsCsDia .btn-baom-con').click(function () {
                $('#OffiCsCsDia').hide()
            })
            $.each(this.actData.giveCourses, function (idx, item) {
                var one = $('#OffiCsCsDia .cs-one:first-child').clone()
                one.find('.img').attr('src', item.shareImageUrl)
                one.data('img', item.shareImageUrl)
                one.data('courseId', item.courseId)
                one.appendTo($('#OffiCsCsDia .cs-con'))
                one.show()
                if (idx > 1) {
                    one.css({
                        marginTop: '0.24rem'
                    })
                }
            })
            $('#OffiCsCsDia .cs-one:first-child').remove()
            $('#OffiCsCsDia .cs-one').click(function () {
                if (!$(this).hasClass('cs-one-now')) {
                    $('.cs-one-now').removeClass('cs-one-now')
                }
                $(this).toggleClass('cs-one-now')
                if ($('.cs-one-now').length > 0) {
                    $('#OffiCsCsDia .go-btn').addClass('go-btn-active')
                } else {
                    $('#OffiCsCsDia .go-btn').removeClass('go-btn-active')
                }
            })
            $('#OffiCsCsDia .go-btn').click(function () {
                var btnText = $(this).text()
                if ($('.cs-one-now').length > 0 && btnText === '确认') {
                    that.showCourseInfoDia()
                }
                if (btnText === '') {
                    $('#OffiCsCsDia').hide()
                    ApiHelper.$emit('reloadCourseList')
                }
            })
        },
        showCourseInfoDia: function () {
            var that = this
            var courseId = $('#OffiCsCsDia .cs-one-now') && $('#OffiCsCsDia .cs-one-now').data('courseId')
            if (!courseId) {
                return
            }
            $('#OffiCsCsDia .yid-con-body').css({
                backgroundImage: 'url("' + that.data.imgPath + 'getCourse_get.png?v=' + window.jspVersionMoreChange + '")'
            })
            $.post(that.data.exchangeCourseUrl, {
                userCouponId: that.actData.userCouponConfigId,
                exchangeCourseIds: courseId
            }, function (res) {
                if (!res || !res.resultCode || res.resultCode.code !== 0) {
                    alert('获取失败，请联系老师反馈哦~')
                    return
                }
                $('#OffiCsCsDia .cs-img').attr('src', $('#OffiCsCsDia .cs-one-now').data('img'))
                $('#OffiCsCsDia .go-btn').text('')
                $('#OffiCsCsDia .cs-con').hide()
                $('#OffiCsCsDia .cs-img').show()
                $('#OffiCsCsDia .kj-djs').text('成功领取7天试看课')
                $('#OffiCsCsDia').addClass('official-cslist-csinfodia')
            })
        },
        // 个人中心
        initUserProfile: function () {
            var that = this
            that.getUserStatus(function () {
                var doubleCard = $('.coupon_entry').clone()
                doubleCard.hide().removeClass('coupon_entry').addClass('call-silent')
                doubleCard.find('img').hide()
                doubleCard.appendTo($('.surprise_entry'))
                setTimeout(function () {
                    doubleCard.find('img').attr('src', that.data.imgPath + 'user_entry.png?v=' + that.data.ver)
                    doubleCard.show();
                    $('.call-silent img').length > 1 && $('.call-silent img:last-child').remove();
                }, 300)
                that.sendExposePvuv({
                    pvuvKeyId: 1406,
                    actId: 10047
                })
                doubleCard.find('img').fadeIn()
                doubleCard.click(function () {
                    that.sendExposePvuv({
                        pvuvKeyId: 1405,
                        actId: 10047
                    }, function () {
                        location.href = ApiHelper.getActUrl() + '/official/friend' + '?channel='
                    })
                })
            })
        },
        // toast消息
        showToast: function (msg, time, callback) {
            if ($('#toastCon').length === 0) {
                $(toastCon).appendTo($('body'))
            }
            $('#toastCon').css({
                display: 'flex'
            })
            $('#toastCon .msg').text(msg)
            setTimeout(function () {
                $('#toastCon').hide()
                callback && callback()
            }, time || 3000)
        },
        // 是否在可视区域 document.addEventListener('scroll', ApiHelper.throttle(function () {}, 500))
        isInView: function (options) {
            var config = {
                selector: options
            }
            if (typeof options !== 'string') {
                config = options
            }
            var selector = config.selector
            var top = config.top || 0 // 头部距离
            var bottom = config.bottom || 0
            if (!document.querySelector(selector)) {
                return false
            }
            var rect = document.querySelector(selector).getBoundingClientRect()
            var flag = false
            if (top <= 1) {
                top = rect.height * top
            }
            top = -rect.height + top
            if (bottom <= 1) {
                bottom = rect.height * bottom
            }
            bottom = window.innerHeight - bottom - (options.extraBtm || 0)
            if (rect.top <= bottom && rect.top >= top) {
                flag = true
            }
            return flag
        },
        // 是否隐藏
        isHideView: function (options) {
            var config = {
                selector: options
            }
            if (typeof options !== 'string') {
                config = options
            }
            var selector = config.selector
            if (!document.querySelector(selector)) {
                return true
            }
            var minBtm = options.extraBtm || 0
            var maxTop = window.innerHeight - minBtm
            var minTop = options.minTop || 0
            var rect = document.querySelector(selector).getBoundingClientRect()
            var flag = false
            if (rect.top > maxTop || rect.bottom < minTop) {
                flag = true
            }
            return flag
        },
        // 插入未来元素
        checkHas: function (selector, callback) {
            var that = this
            var addBannerCount = 0

            function check() {
                setTimeout(function () {
                    addBannerCount++
                    if ($(selector).length > 0) {
                        callback && callback.call(that)
                    } else {
                        addBannerCount < 5 && check()
                    }
                }, 1000)
            }

            check()
        },
        getStorageSync: function (key) {
            var storage = localStorage.getItem(key)
            try {
                storage = JSON.parse(storage)
            } catch (e) {
                storage = storage
            }
            return storage
        },
        setStorageSync: function (key, data) {
            localStorage.setItem(key, JSON.stringify(data))
        },
        //倒计时
        doubleEvelenTimeDown: function (cutDownTime) {
            var oneDay = 24 * 60 * 60 * 1000
            var that = this
            var courseTime = setInterval(function () {
                cutDownTime -= 10
                if (cutDownTime > oneDay) {
                    var hh = Math.floor(cutDownTime / 1000 / 60 / 60 % 24)
                    var dd = Math.floor(cutDownTime / 1000 / 60 / 60 / 24)
                    dd = dd > 99 ? 99 : dd
                    var mm = parseInt(cutDownTime / 1000 / 60 % 60)
                    var ss = parseInt(cutDownTime / 1000 % 60)
                    var ms = parseInt(cutDownTime / 100 % 10)
                    hh = (hh >= 0 && hh < 10) ? ("0" + hh) : hh   //时
                    mm = (mm >= 0 && mm < 10) ? ("0" + mm) : mm   //分
                    ss = (ss >= 0 && ss < 10) ? ("0" + ss) : ss   //秒
                    ms = (ms >= 0 && ms < 10) ? ("0" + ms) : ms   //秒
                    $('.countDownNum11').html('<span class="days">' + dd + '天' + '<span class="hours">' + hh + '</span><span class="time_sign">:</span><span class="hours">' + mm + '</span><span class="time_sign">:</span><span class="hours">' + ss + '</span><span class="time_sign">:</span><span class="hours">' + ms + '</span>')
                } else {
                    var hh = Math.floor(cutDownTime / 1000 / 60 / 60)
                    var mm = parseInt(cutDownTime / 1000 / 60 % 60)
                    var ss = parseInt(cutDownTime / 1000 % 60)
                    var ms = parseInt(cutDownTime / 100 % 10)
                    if (hh < 0 || mm < 0 || ss < 0 || ms < 0) {
                        hh = 0
                        mm = 0
                        ss = 0
                        ms = 0
                        clearInterval(courseTime)
                    }
                    hh = (hh >= 0 && hh < 10) ? ("0" + hh) : hh   //时
                    mm = (mm >= 0 && mm < 10) ? ("0" + mm) : mm   //分
                    ss = (ss >= 0 && ss < 10) ? ("0" + ss) : ss   //秒
                    ms = (ms >= 0 && ms < 10) ? ("0" + ms) : ms   //秒
                    $('.coupon_time_h').text(hh)
                    $('.coupon_time_m').text(mm)
                    $('.coupon_time_s').text(ss)
                    $('.coupon_time_ms').text(ms)
                }
                clearInterval(courseTime)
                that.doubleEvelenTimeDown(cutDownTime)
            }, 10)
        }
    }
</script>

<style scoped lang="less">
    .flex-row {
        display: -moz-box;
        /* 老版本语法: Firefox (buggy) */
        display: -ms-flexbox;
        /* 混合版本语法: IE 10 */
        display: -webkit-flex;
        /* 新版本语法: Chrome 21+ */
        display: flex;
    }

    @cl-mask: rgba(0, 0, 0, 0.85);
    /**弹窗**/
    .yidialog-con {
        position: fixed;
        width: 100%;
        height: 100%;
        top: 0px;
        left: 0px;
        display: flex;
        align-items: center;
        justify-content: center;
        z-index: 1000;

        .yid-back {
            position: absolute;
            left: 0px;
            top: 0px;
            width: 100%;
            height: 100%;
            text-align: center;
            background: @cl-mask;
        }

        .yid-con {
            position: relative;
            display: flex;
            justify-content: center;
            align-content: center;
            color: #ffffff;
            flex-wrap: wrap;

            .yid-cls {
                position: relative;
                z-index: 9999;
                width: 0.51rem;
                height: 0.51rem;
                flex-shrink: 0;
            }

            .yid-hand {
                position: absolute;
                width: 1rem;
                top: 3.1rem;
                right: 0.1rem;
                animation: handClick 1s infinite;
            }
        }

        .yid-con-col {
            flex-direction: column;
        }
    }

    /**toast**/
    .yid-toast-con {
        display: none;

        .yid-back {
            opacity: 0;
        }

        .yid-con {
            .yid-con-body {
                justify-content: center;
                align-items: center;

                .msg {
                    padding: 20px;
                    background-color: #333333;
                    color: #ffffff;
                    font-size: 28px;
                    border-radius: 10px;
                }
            }
        }
    }

    /**我的课程**/
    .official-icon {
        position: fixed;
        width: 148px;
        height: 108px;
        left: unset;
        right: 19px;
        bottom: 263px;
        background-color: transparent;
        overflow: hidden;

        .icon {
            width: 148px;
            height: 108px;
        }

        .icon_2 {
            height: 0;
        }
    }

    .official-cslist-cpdia {
        .yid-con-body {
            width: 600px;
            height: 878px;
            background-repeat: no-repeat;
            background-position: center top;
            background-size: 100% auto;
            position: relative;
            justify-content: center;

            .coupon-img {
                width: 348px;
                height: 264px;
                margin-top: 300px;
                animation: sc_zy 0.8s linear infinite;
                transform-origin: center;
            }

            .go-btn {
                width: 280px;
                height: 90px;
                position: absolute;
                bottom: 141px;
                left: 160px;
            }

            .btn-baom-con {
                position: absolute;
                width: 50px;
                height: 50px;
                bottom: 0;
                left: 275px;
            }
        }
    }

    .official-cslist-csdia {
        .yid-con-body {
            flex-direction: column;
            align-items: center;
            width: 600px;
            height: 1066px;
            background-repeat: no-repeat;
            background-position: center top;
            background-size: 100% auto;
            position: relative;

            .kj-djs {
                margin-top: 90px;
            }

            .cs-con {
                width: 520px;
                height: 626px;
                margin-top: 100px;
                overflow-y: auto;
                -webkit-overflow-scrolling: touch;
                flex-wrap: wrap;

                .cs-one {
                    width: 250px;
                    height: 250px;
                    flex-shrink: 0;
                    display: none;
                    border-radius: 24px;

                    .img {
                        border-radius: 24px;
                    }
                }

                .cs-one-now {
                    width: 238px;
                    height: 238px;
                    border: solid 6px #ff4c00;
                }

                .cs-one:nth-child(even) {
                    margin-left: 20px;
                }
            }

            .go-btn {
                margin-top: 40px;
                background-color: #999999;
                color: #ffffff;
                width: 280px;
                height: 90px;
                border-radius: 45px;
                justify-content: center;
                align-items: center;
                flex-shrink: 0;
            }

            .go-btn-active {
                background-color: #ffab00;
            }

            .btn-baom-con {
                position: absolute;
                width: 50px;
                height: 50px;
                bottom: 0;
                left: 275px;
            }
        }
    }

    .official-cslist-csinfodia {
        .yid-con-body {
            height: 780px;

            .kj-djs {
                margin-top: 59px;
            }

            .cs-img {
                width: 254px;
                height: 254px;
                margin-top: 65px;
                border-radius: 24px;
            }

            .go-btn {
                margin-top: 162px;
                background-color: transparent;
            }
        }
    }

    @keyframes sc_zy {
        0% {
            transform: rotate(15deg);
        }
        25% {
            transform: rotate(0deg);
        }
        50% {
            transform: rotate(-15deg);
        }
        75% {
            transform: rotate(0deg);
        }
        100% {
            transform: rotate(15deg);
        }
    }

    /**试看课程目录**/
    .official-free-cslist {
        position: fixed;
        flex-direction: column;
        bottom: 0;
        left: 0;
        right: 0;
        color: #ffffff;

        .time-con {
            width: 360px;
            height: 60px;
            line-height: normal;
            align-items: center;
            justify-content: center;
            align-self: center;
            background-repeat: no-repeat;
            background-position: center center;
            background-size: 100% auto;
            font-size: 28px;
            display: none;
        }

        .btn-con {
            height: 108px;
            align-items: center;
            margin-top: 30px;
            justify-content: center;
            position: relative;
            overflow: hidden;

            .dang, .tuang {
                justify-content: center;
                align-items: center;
                flex-grow: 1;
                height: 100%;
                background-color: #FF4E01;
                flex-direction: column;

                .price {
                    font-size: 36px;
                    align-items: center;

                    .mark {
                        font-size: 24px;
                        margin-left: 8px;
                    }
                }

                .desc {
                    font-size: 24px;
                    margin-top: 10px;
                }
            }

            .dang {
                width: 240px;
                flex-grow: 0;
                background-color: #FF7537;
            }

            .badge {
                position: absolute;
                top: -76px;
                right: -77px;
                color: #FC4329;
                font-size: 32px;
                width: 153px;
                height: 153px;
                background-color: #FFDF00;
                transform: rotate(45deg);
                justify-content: center;
                align-items: flex-end;
                font-weight: bold;
                display: none;

                .t {
                    margin-bottom: 10px;
                }
            }
        }
    }

    .my-hand-ani {
        animation: myHandAni 1s infinite;
    }

    @keyframes myHandAni {
        50% {
            left: 80px;
        }
        0%, 100% {
            left: 50px;
        }
    }

    @keyframes iconClick {
        0%, 100% {
            margin-bottotm: 0;
        }
        50% {
            margin-bottom: -35px;
            transform: scale(1.1);
        }
    }

    @keyframes handClick {
        from {
            margin-top: 0rem;
            margin-right: 0rem;
        }
        50% {
            margin-top: -0.1rem;
            margin-right: 0.1rem;
            transform: scale(0.9);
        }
        to {
            margin-top: -0rem;
            margin-right: 0rem;
        }
    }

    .scale-size {
        animation: scaleSize 2s infinite;
    }

    @keyframes scaleSize {
        from {
            transform: scale(0.9);
            opacity: 0.9;
        }
        50% {
            transform: scale(1.2);
            opacity: 1;
        }
        to {
            transform: scale(0.9);
            opacity: 0.9;
        }
    }

    .heart-beat {
        animation: heartBeat 1s infinite;
    }

    @keyframes heartBeat {
        0% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }

        14% {
            -webkit-transform: scale(.8);
            transform: scale(.8);
        }

        28% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }

        42% {
            -webkit-transform: scale(.8);
            transform: scale(.8);
        }

        70% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }
    }

    /**淡入*/
    .fade-in {
        animation: fadeIn 1s;
    }

    @keyframes fadeIn {
        from {
            opacity: 0;
        }
        to {
            opacity: 1;
        }
    }
</style>
